JUCE: DialogWindow::LaunchOptions Struct Reference

JUCE

Public Member Functions | Public Attributes | List of all members
DialogWindow::LaunchOptions Struct Reference
juce_gui_basics » windows

This class defines a collection of settings to be used to open a DialogWindow. More...

`#include <juce_DialogWindow.h>`

## Public Member Functions
| LaunchOptions () noexcept
DialogWindow * | launchAsync ()
| Launches a new modal dialog window. More...
DialogWindow * | create ()
| Creates a new DialogWindow instance with these settings. More...
int | runModal ()
| Launches and runs the dialog modally, returning the status code that was used to terminate the modal loop. More...

## Public Attributes
String | dialogTitle
| The title to give the window. More...
Colour | dialogBackgroundColour = Colours::lightgrey
| The background colour for the window. More...
OptionalScopedPointer< Component > | content
| The content component to show in the window. More...
Component * | componentToCentreAround = nullptr
| If this is not a nullptr, it indicates a component that you'd like to position this dialog box in front of. More...
bool | escapeKeyTriggersCloseButton = true
| If true, then the escape key will trigger the dialog's close button. More...
bool | useNativeTitleBar = true
| If true, the dialog will use a native title bar. More...
bool | resizable = true
| If true, the window will be resizable. More...
bool | useBottomRightCornerResizer = false
| Indicates whether to use a border or corner resizer component. More...

## Detailed Description

This class defines a collection of settings to be used to open a DialogWindow.

The easiest way to open a DialogWindow is to create yourself a LaunchOptions structure, initialise its fields with the appropriate details, and then call its launchAsync() method to launch the dialog.

## Constructor & Destructor Documentation

## ◆ LaunchOptions()

DialogWindow::LaunchOptions::LaunchOptions | ( |  | ) |
| noexcept

## Member Function Documentation

## ◆ launchAsync()

DialogWindow * DialogWindow::LaunchOptions::launchAsync | ( |  | ) |

Launches a new modal dialog window.

This will create a dialog based on the settings in this structure, launch it modally, and return immediately. The window that is returned will be automatically deleted when the modal state is terminated.

When the dialog's close button is clicked, it'll automatically terminate its modal state, but you can also do this programmatically by calling exitModalState (returnValue) on the DialogWindow.

If your content component needs to find the dialog window that it is contained in, a quick trick is to do this:

if (DialogWindow* dw = contentComponent->findParentComponentOfClass<DialogWindow>())
dw->exitModalState (1234);
Component::findParentComponentOfClass
TargetClass * findParentComponentOfClass() const
Searches the parent components for a component of a specified class.
Definition: juce_Component.h:814
DialogWindow
A dialog-box style window.
Definition: juce_DialogWindow.h:53

Referenced by StandalonePluginHolder::showAudioSettingsDialog().

## ◆ create()

DialogWindow * DialogWindow::LaunchOptions::create | ( |  | ) |

Creates a new DialogWindow instance with these settings.

This method simply creates the window, it doesn't run it modally. In most cases you'll want to use launchAsync() or runModal() instead.

## ◆ runModal()

int DialogWindow::LaunchOptions::runModal | ( |  | ) |

Launches and runs the dialog modally, returning the status code that was used to terminate the modal loop.

Note that running modal loops inline is a BAD technique. If possible, always use launchAsync() instead of this method.

## Member Data Documentation

## ◆ dialogTitle

String DialogWindow::LaunchOptions::dialogTitle

The title to give the window.

Referenced by StandalonePluginHolder::showAudioSettingsDialog().

## ◆ dialogBackgroundColour

Colour DialogWindow::LaunchOptions::dialogBackgroundColour = Colours::lightgrey

The background colour for the window.

Referenced by StandalonePluginHolder::showAudioSettingsDialog().

## ◆ content

OptionalScopedPointer<Component> DialogWindow::LaunchOptions::content

The content component to show in the window.

This must not be null! Using an OptionalScopedPointer to hold this pointer lets you indicate whether you'd like the dialog to automatically delete the component when the dialog has terminated.

Referenced by StandalonePluginHolder::showAudioSettingsDialog().

## ◆ componentToCentreAround

Component* DialogWindow::LaunchOptions::componentToCentreAround = nullptr

If this is not a nullptr, it indicates a component that you'd like to position this dialog box in front of.

See the DocumentWindow::centreAroundComponent() method for more info about this parameter.

## ◆ escapeKeyTriggersCloseButton

bool DialogWindow::LaunchOptions::escapeKeyTriggersCloseButton = true

If true, then the escape key will trigger the dialog's close button.

Referenced by StandalonePluginHolder::showAudioSettingsDialog().

## ◆ useNativeTitleBar

bool DialogWindow::LaunchOptions::useNativeTitleBar = true

If true, the dialog will use a native title bar.

See TopLevelWindow::setUsingNativeTitleBar()

Referenced by StandalonePluginHolder::showAudioSettingsDialog().

## ◆ resizable

bool DialogWindow::LaunchOptions::resizable = true

If true, the window will be resizable.

See ResizableWindow::setResizable()

Referenced by StandalonePluginHolder::showAudioSettingsDialog().

## ◆ useBottomRightCornerResizer

bool DialogWindow::LaunchOptions::useBottomRightCornerResizer = false

Indicates whether to use a border or corner resizer component.

See ResizableWindow::setResizable()

The documentation for this struct was generated from the following file:

- juce_DialogWindow.h